/* Cytec Matrix Test Program for LAN                 */
/* This program uses Microsoft's WS2_32 Library		 */
/* and winsock2.h. These are available in the		 */
/* Microsoft SDKs and can be downloaded from         */
/* Microsoft's Developer Network 					 */
/* https://msdn.microsoft.com/en-us/default.aspx	 */

#include "matrix_ops.h"

#define MAX_MTX	1
#define MAX_MOD	4
#define MAX_RLY 12

int main()
{
	int sock;
	char servIP[40];
	struct sockaddr_in servAddr; /* Echo server address */   
	unsigned short servPort;     /* Echo server port */ 
    int mtx, mod, rly,status; 

	servPort = 8080;
	strcpy(servIP,"10.0.0.26");
	
	WSADATA wsaData;                 /* Structure for WinSock setup communication */ 
	WSAStartup(0x202, &wsaData);	 /* Load Winsock 2.2 DLL */  
	
	/* Create a reliable, stream socket using TCP */        
	if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP))<0)
		DieWithError("socket() failed");   
	
	/* Construct the server address structure */ 		   
	memset(&servAddr, 0, sizeof(servAddr));     /* Zero out structure */
    servAddr.sin_family      = AF_INET;             /* Internet address family */
    servAddr.sin_addr.s_addr = inet_addr(servIP);   /* Server IP address */
    servAddr.sin_port        = htons(servPort); /* Server port */
	
    /* Establish the connection to the server */
    if (connect(sock, (struct sockaddr *) &servAddr, sizeof(servAddr))<0)
			DieWithError("connect() failed");  
	
	/* Initialize Device using Utility Function */
	init_LAN(sock);
	
	/* Send Clear Command to Device */
	if ((status = matrix_clear(sock)) != 48)
		printf("Error clearing device/n");
	
	/* Simple looping through switchpoints */
	
	for(mtx=0; mtx<MAX_MTX; mtx++)
	{
		for (mod=0; mod<MAX_MOD; mod++) 
		{
				for (rly=0; rly<MAX_RLY; rly++) 
				{  
					if (((status = point_ops(sock,'L',mtx,mod,rly))) !=49)
						printf("Error point %d %d %d not closed\n",mtx,mod,rly);
					else 
						printf("Latched point %d %d\n",mod, rly);
					
					if (((status = point_ops(sock,'U',mtx,mod,rly))) !=48)
						printf("Error point %d %d %d not open\n",mtx,mod,rly);
					else
						printf("Unlatched point %d %d\n",mod, rly); 
				}
		}
	}
	closesocket(sock);  
	WSACleanup();  /* Cleanup Winsock */ 
	return 0;
}











