/*****************************************************************************
 *  Step Parameters for Chroma 19073                                                               
 *  Original Release:                                  
 *  By: Nicky Heywood                             
 *      PH. 585-381-4740                             
 *                                                                           
 *  Modification History:                                                    
 *                                                                           
 *        -  Created.                  
 *                                                                           
 *****************************************************************************/
 
#include <ansi_c.h>
#include <stdio.h>
#include RS485.h
#include StepParameters.h

#define BUFFER_SIZE 512
#define COMMAND_CODE 0x24

unsigned char outputPacket[BUFFER_SIZE/2]; 
//-------------------Main--------------------------------------------------------
main ()
{
    unsigned char da = 0x70;
	unsigned char sa = 0x01;
	int step = 1;
	int source = 1000;
	int rampTime = 2;
	int testTime = 5;
	int fallTime = 3;
	int highLimit = 10000;
	int lowLimit = 1000;
	int arcLimit = 10000;
    ACMode(da,sa,step,source,rampTime,testTime,fallTime,highLimit,lowLimit,arcLimit);
}
//------------------ACMode-------------------------------------------------------

int ACMode(unsigned char[] destAddr,unsigned char[] sourceAddr, int stepIndex, 
              int source, int rampTime, int testTime, int fallTime,
              int highLimit, int lowLimit, int arcLimit)
{
	unsigned char dataFieldLength = 0x1D;	
	
	outputPacket[PACK_HEADERPOS] = (unsigned char)PACK_HEADER;
	outputPacket[PACK_DAPOS] = destAddr;
	outputPacket[PACK_SAPOS] = sourceAddr;
	outputPacket[PACK_LENPOS] = dataFieldLength;  
    outputPacket[PACK_CMDPOS] = (unsigned char)COMMAND_CODE;
	outputPacket[PACK_PARA1POS]	= GetStepIndex(stepIndex);
	outputPacket[PACK_PARA2POS] = 0x01;
	
	for (int i=0;i<8;i++)
	{
		printf("%c",outputPacket[i]);
	}
		
}
//---------------StepIndex---------------------------------------------------------

unsigned char GetStepIndex(int stepIndex)
{
	unsigned char hexval;
	if (0 <= stepIndex < 11)
	{
		sprintf(hexval,"%0x",stepIndex);
	}
	else 
	{
		hexval = '\0';
	}
	return hexval;	
}

//---------------RampTime---------------------------------------------------------

unsigned char[] GetRampTime(int rampTime)
{
	double unit = 0.1;
	rampTime = rampTime/unit;
	unsigned char hexval[2];
	if (0 <= rampTime < 9991)
	{
		sprintf(hexval[0],"%0x",ramptime%256);
		sprintf(hexval[1],"%0x",ramptime/256);
	}
	else 
	{
		hexval[0] = '\0';
		hexval[1] = '\0''
	}
	return hexval;	
}

//--------------ConvertToHex------------------------------------------------------
	
unsignedchar[] ConvertToHex(int intToConvert)
{
	int quotient = intToConvert/16;
	int remainder = intToConvert%16;
	int digit = 0;
	unsigned char hex[8];
	
	while (quotient > 0)
	{
	    if (remainder < 10) 
	    {
	        hex[digit] = '0' + remainder;
	    }
	    else
	    {
	    	hex[digit] = '7' + remainder;
	    }
		quotient =quotient/16;
		remainder =quotient%16;
		digit++;
	}
	
	for (int i=digit;i<=8;i++)
	{
		hex[i] = '0';
	}
		
	return hex;
}
	
