/* Cytec Matrix Test Program for LAN                 */
/* This program uses Microsoft's WS2_32 Library		 */
/* and winsock2.h. These are available in the		 */
/* Microsoft SDKs and can be downloaded from         */
/* Microsoft's Developer Network 					 */
/* https://msdn.microsoft.com/en-us/default.aspx	 */


#include "matrix_ops.h"



/*--------------Initialize---------------------------*/

int init_LAN(int sock)
{
	char rcvString[40];     /* Buffer for device response */
    int rcvStringLen;      /* Length of device response */
	void DieWithError(char *errorMessage);
	/* Initialize Device */		 
	if ((send(sock, "E0 73;V0 73;TCPANSWERBACK 1\n", 28, 0)) != 28)
	{
			DieWithError("send() failed");   
	}
	Sleep(1000);	  /* Wait for Response from Device */
	if ((rcvStringLen = recv(sock, rcvString, 9, 0)) < 9)
	{
			DieWithError("recv() failed or connection closed prematurely");
	}
	rcvString[rcvStringLen] = '\0';
	return 0;
}

/*-----------------Clear Matrix----------------------*/

int matrix_clear(int sock)
{

	char rcvString[8];     /* Buffer for device response */
    int rcvStringLen;      /* Length of device response */
	
    if ((send(sock,"C\n",2,0)) != 2)  
			DieWithError("send() failed");
			
	Sleep(200);   /* Wait for Response
	
	/* Receive Response from Device */
	if ((rcvStringLen = recv(sock, rcvString, 10, 0)) <= 0)
			DieWithError("recv() failed or connection closed prematurely"); 
    rcvString[rcvStringLen] = '\0';
	int status = rcvString[0] & 0x3f;

	return status;  
}
/*-----------Switchpoint Operation------------------  */

int point_ops(int sock,int cmd, int mtx, int mod, int rly)
{
	char cmd_str[40];	   /* Formatted command string */
	char rcvString[8];     /* Buffer for device response */
    int rcvStringLen;      /* Length of device response */

	/* Format String */
	sprintf(cmd_str,"%c%d %d %d\n",cmd,mtx,mod,rly);
	
	/* Send Command to Device */
	if ((send(sock,cmd_str,strlen(cmd_str),0)) != strlen(cmd_str))  
			DieWithError("send() failed");
			
	Sleep(200);   /* Wait for Response
	
	/* Receive Response from Device */
	if ((rcvStringLen = recv(sock, rcvString, 10, 0)) <= 0)
			DieWithError("recv() failed or connection closed prematurely"); 
    rcvString[rcvStringLen] = '\0';
	int status = rcvString[0] & 0x3f;

	return status;
}

/*------------Error Handling Function---------------------*/
	
 void DieWithError(char *errorMessage)
{
    fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
	getchar();
    exit(1);
}
